Page MenuHomePhabricator

[SVE][CodeGen] Extend index of masked gathers
ClosedPublic

Authored by kmclaughlin on Nov 13 2020, 8:49 AM.

Details

Summary

This patch changes performMSCATTERCombine to also promote the indices of
masked gathers where the element type is i8 or i16, and adds various tests
for gathers with illegal types.

Diff Detail

Event Timeline

kmclaughlin created this revision.Nov 13 2020, 8:49 AM
Herald added a project: Restricted Project. · View Herald TranscriptNov 13 2020, 8:49 AM
sdesmalen accepted this revision.Nov 24 2020, 3:28 AM

LGTM

llvm/lib/Target/AArch64/AArch64ISelLowering.cpp
15312

It would be good if you can see if such functionality can be moved to SelectionDAGBuilder where some target interface queries if the index needs to be extended. Doing this with a target DAG combine is fine for this patch I think.

This revision is now accepted and ready to land.Nov 24 2020, 3:28 AM
This revision was landed with ongoing or failed builds.Dec 10 2020, 5:55 AM
This revision was automatically updated to reflect the committed changes.